"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _vue = require("vue");

var _react = require("react");

var _store = require("svelte/store");

var _svelte = require("svelte");

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { if (!(Symbol.iterator in Object(arr) || Object.prototype.toString.call(arr) === "[object Arguments]")) { return; } var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var Store =
/*#__PURE__*/
function () {
  function Store(initialState, selectors) {
    var _this = this;

    _classCallCheck(this, Store);

    _defineProperty(this, "reactiveState", void 0);

    _defineProperty(this, "reactiveSelectors", void 0);

    _defineProperty(this, "stateStopWatches", new Map());

    _defineProperty(this, "selectorStopWatches", new Map());

    _defineProperty(this, "stateWritables", new Map());

    _defineProperty(this, "componentId", 0);

    this.reactiveState = (0, _vue.reactive)(initialState);
    this.reactiveSelectors = {};

    if (selectors) {
      Object.keys(selectors).forEach(function (key) {
        return _this.reactiveSelectors[key] = (0, _vue.computed)(function () {
          return (// eslint-disable-next-line @typescript-eslint/ban-ts-ignore
            // @ts-ignore
            selectors[key](_this.reactiveState)
          );
        });
      });
    }
  }

  _createClass(Store, [{
    key: "getState",
    value: function getState() {
      return this.reactiveState;
    }
  }, {
    key: "getSelectors",
    value: function getSelectors() {
      return this.reactiveSelectors;
    }
  }, {
    key: "getStateAndSelectors",
    value: function getStateAndSelectors() {
      return [this.reactiveState, this.reactiveSelectors];
    } // eslint-disable-next-line @typescript-eslint/no-explicit-any

  }, {
    key: "useStateAndSelectorsReact",
    value: function useStateAndSelectorsReact(subStates, selectors) {
      this.useStateReact(subStates);
      this.useSelectorsReact(selectors);
    }
  }, {
    key: "useStateReact",
    value: function useStateReact(subStates) {
      var _useState = (0, _react.useState)({}),
          _useState2 = _slicedToArray(_useState, 2),
          updateViewDueToStateChange = _useState2[1];

      (0, _react.useEffect)(function () {
        var stopWatches = [];
        subStates.forEach(function (subState) {
          if (!subState.__isSubState__) {
            throw new Error('useState: One of given subStates is not subState');
          }

          stopWatches.push((0, _vue.watch)(function () {
            return subState;
          }, function () {
            return updateViewDueToStateChange({});
          }, {
            deep: true
          }));
        });
        return function () {
          return stopWatches.forEach(function (stopWatch) {
            return stopWatch();
          });
        };
      }, []);
    } // eslint-disable-next-line @typescript-eslint/no-explicit-any

  }, {
    key: "useSelectorsReact",
    value: function useSelectorsReact(selectors) {
      var _useState3 = (0, _react.useState)({}),
          _useState4 = _slicedToArray(_useState3, 2),
          updateViewDueToSelectorChange = _useState4[1];

      (0, _react.useEffect)(function () {
        var stopWatches = []; // eslint-disable-next-line @typescript-eslint/no-explicit-any

        selectors.forEach(function (selector) {
          stopWatches.push((0, _vue.watch)(function () {
            return selector;
          }, function () {
            return updateViewDueToSelectorChange({});
          }, {
            deep: true
          }));
        });
        return function () {
          return stopWatches.forEach(function (stopWatch) {
            return stopWatch();
          });
        };
      }, []);
    } // eslint-disable-next-line @typescript-eslint/no-explicit-any

  }, {
    key: "useStateAndSelectorsNg",
    value: function useStateAndSelectorsNg(componentInstance, subStateMap, // eslint-disable-next-line @typescript-eslint/no-explicit-any
    selectorMap) {
      this.useStateNg(componentInstance, subStateMap);
      this.useSelectorsNg(componentInstance, selectorMap);
    } // eslint-disable-next-line @typescript-eslint/no-explicit-any

  }, {
    key: "useStateNg",
    value: function useStateNg(componentInstance, subStateMap) {
      var _this2 = this;

      this.stateStopWatches.set(componentInstance, []);
      Object.entries(subStateMap).forEach(function (_ref) {
        var _ref2 = _slicedToArray(_ref, 2),
            stateName = _ref2[0],
            subState = _ref2[1];

        if (!subState.__isSubState__) {
          throw new Error('useState: One of given subStates is not subState');
        }

        componentInstance[stateName] = subState;

        _this2.stateStopWatches.get(componentInstance).push((0, _vue.watch)(function () {
          return subState;
        }, function () {
          return componentInstance[stateName] = subState;
        }, {
          deep: true
        }));
      });
      var originalOnDestroy = componentInstance.ngOnDestroy;

      componentInstance.ngOnDestroy = function () {
        _this2.stateStopWatches.get(componentInstance).forEach(function (stopWatch) {
          return stopWatch();
        });

        if (originalOnDestroy) {
          originalOnDestroy();
        }
      };
    } // eslint-disable-next-line @typescript-eslint/no-explicit-any

  }, {
    key: "useSelectorsNg",
    value: function useSelectorsNg(componentInstance, // eslint-disable-next-line @typescript-eslint/no-explicit-any
    selectorMap) {
      var _this3 = this;

      this.selectorStopWatches.set(componentInstance, []); // eslint-disable-next-line @typescript-eslint/no-explicit-any

      Object.entries(selectorMap).forEach(function (_ref3) {
        var _ref4 = _slicedToArray(_ref3, 2),
            selectorName = _ref4[0],
            selector = _ref4[1];

        componentInstance[selectorName] = selector.value;

        _this3.selectorStopWatches.get(componentInstance).push((0, _vue.watch)(function () {
          return selector;
        }, function () {
          return componentInstance[selectorName] = selector.value;
        }, {
          deep: true
        }));
      });
      var originalOnDestroy = componentInstance.ngOnDestroy;

      componentInstance.ngOnDestroy = function () {
        _this3.selectorStopWatches.get(componentInstance).forEach(function (stopWatch) {
          return stopWatch();
        });

        if (originalOnDestroy) {
          originalOnDestroy();
        }
      };
    }
  }, {
    key: "useStateSvelte",
    value: function useStateSvelte(subStates) {
      var _this4 = this;

      var id = this.componentId++;
      this.stateStopWatches.set(id, []);
      this.stateWritables.set(id, []);
      subStates.forEach(function (subState, index) {
        _this4.stateWritables.get(id).push((0, _store.writable)(subState));

        _this4.stateStopWatches.get(id).push((0, _vue.watch)(function () {
          return subState;
        }, function () {
          return _this4.stateWritables.get(id)[index].set(subState);
        }, {
          deep: true
        }));
      });
      (0, _svelte.onDestroy)(function () {
        return _this4.stateStopWatches.get(id).forEach(function (stopWatch) {
          return stopWatch();
        });
      });
      return this.stateWritables.get(id);
    } // eslint-disable-next-line @typescript-eslint/no-explicit-any

  }, {
    key: "useSelectorsSvelte",
    value: function useSelectorsSvelte(selectors) {
      var _this5 = this;

      var id = this.componentId++;
      this.stateStopWatches.set(id, []);
      this.stateWritables.set(id, []); // eslint-disable-next-line @typescript-eslint/no-explicit-any

      selectors.forEach(function (selector, index) {
        _this5.stateWritables.get(id).push((0, _store.writable)(selector.value));

        _this5.stateStopWatches.get(id).push((0, _vue.watch)(function () {
          return selector;
        }, function () {
          return _this5.stateWritables.get(id)[index].set(selector.value);
        }, {
          deep: true
        }));
      });
      (0, _svelte.onDestroy)(function () {
        return _this5.stateStopWatches.get(id).forEach(function (stopWatch) {
          return stopWatch();
        });
      });
      return this.stateWritables.get(id);
    }
  }]);

  return Store;
}();

exports.default = Store;
//# sourceMappingURL=Store.js.map